import java.sql.*;
import javax.sql.*;
import java.util.*;
import javax.ejb.*;
import javax.naming.*;

public class BookEJB implements EntityBean {
	private String isbn;
	private String title;
	private String author;
	private long price;
	private EntityContext context;
	private Connection conn;
		
	public String getIsbn() {
		return isbn;
	}
	public String getTitle() {
		return title;
	}
	public String getAuthor() {
		return author;
	}
	public long getPrice() {
		return price;
	}
	public String ejbCreate(String isbn, String title, String author, long price)
	throws CreateException {
		if (price < 0) {
			throw new CreateException("price 0  Ŀ մϴ.");
		}
		try {
			String query =
			"insert into book values (" + makeSQL(isbn) + "," + makeSQL(title)
			 + "," + makeSQL(author) + "," + price + ")"; 
			 System.out.println(query);
			Statement stmt = 
			conn.createStatement();
			stmt.executeUpdate(query);
			stmt.close();
		} catch (Exception e) {
			throw new EJBException("ejbCreate: " + e.getMessage());
		}
		this.isbn = isbn;
		this.title = title;
		this.author = author;
		this.price = price;
		return isbn;
	}
	
	public String ejbFindByPrimaryKey(String primaryKey) 
	throws FinderException {
		boolean result;
		try {
			String query =
			"select isbn from book where isbn =" + makeSQL(primaryKey);
			System.out.println(query);
			Statement stmt =conn.createStatement();
			ResultSet rset = stmt.executeQuery(query);
			result = rset.next();
			stmt.close();
		} catch (Exception e) {
			throw new EJBException("ejbFindByPrimaryKey: " + e.getMessage());
		}
		if (result) {
			return primaryKey;
		} else {
			throw new ObjectNotFoundException("ejbCreate: isbn " +  primaryKey + 
			"  ̺ ڵ尡  ʽϴ.");
		}
	}
	
	public Collection ejbFindByTitle(String title) throws FinderException {
		Collection  ret;
		try {
			String query = "select isbn from book where title =" + makeSQL(title);
			Statement stmt = 
			conn.createStatement();
			ResultSet rset = stmt.executeQuery(query);
			ret = new Vector();
			while (rset.next()) {
				String isbn = rset.getString(1);
				ret.add(isbn);
			}
			stmt.close();
		} catch (Exception e) {
			throw new EJBException("ejbFindByTitle: " + e.getMessage());
		}
		if (ret.isEmpty()) {
			throw new ObjectNotFoundException("ejbFindByTitle: title  " 
			+  title + " ڵ尡  ʽϴ.");
		} else {
			return ret;
		}
	}
	
	public void ejbRemove() {
		try {
			String query =	"delete from book where isbn =" + makeSQL(isbn);
			Statement stmt =
			conn.createStatement();
			stmt.executeUpdate(query);
			stmt.close();
		} catch (Exception e) {
			throw new EJBException("ejbRemove: " + 
			e.getMessage());
		}
	} 
	public void setEntityContext(EntityContext context) {
		this.context = context;
		try {
			InitialContext ic = new InitialContext();
			DataSource ds = (DataSource) ic.lookup("java:comp/env/jdbc/Book");
			conn =  ds.getConnection("scott", "tiger");
		} catch (Exception e) {
			throw new EJBException(" ̽ Ŀؼ ! " +
			e.getMessage());
		}
	}
	public void unsetEntityContext() {
		try {
			conn.close();
		} catch (SQLException e) {
			throw new EJBException("unsetEntityContext: " + e.getMessage());
		}
	}
	public void ejbActivate() {
		isbn = (String)context.getPrimaryKey();
	}
	public void ejbPassivate() {
		isbn = null;
	}
	public void ejbLoad() {
		try {
			String query = "select title, author, price " +
			"from book where isbn =" + makeSQL(isbn);
			Statement stmt = 
			conn.createStatement();
			ResultSet rset = stmt.executeQuery(query);
			if (rset.next()) {
				this.title = rset.getString(1);
				this.author = rset.getString(2);
				this.price = rset.getLong(3);
				stmt.close();
			} else {
				stmt.close();
				throw new NoSuchEntityException("ejbLoad: isbn " + isbn +
				"  ͺ̽ ڵ尡  ʽϴ.");
			}
		} catch (Exception e) {
			throw new EJBException("ejbLoad: " + 
			e.getMessage());
		}
	}
	public void ejbStore() {
		try {
			String query = "update book set title =" + makeSQL(title) + " ," 
			+ "author =" + makeSQL(author) + ",price=" + price + " where isbn=" + makeSQL(isbn);
			Statement stmt = conn.createStatement();
			int rowCount = stmt.executeUpdate(query);
			stmt.close();
			if (rowCount == 0) {
				throw new EJBException("ejbStore: ƼƼ   ͺ̽ ϴµ  ");
			}
		} catch (Exception e) {
			throw new EJBException("ejbStore: " + 
			e.getMessage());
		}
	}
	public void ejbPostCreate(String isbn, String title, String author, long price) {}
	
	private String makeSQL(String str) {
		if(str == null) return str;
		return "'" + str + "'";
	}
}